//
//  CoreAudioMixer.mm
//  S98Player
//
//  Created by Hiroaki on 06/01/17.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "CoreAudioMixer.h"
#include <unistd.h>


@implementation CoreAudioMixer
Speaker* sp;


OSStatus	MyRenderer(void 				*inRefCon, 
					   AudioUnitRenderActionFlags 	*ioActionFlags, 
					   const AudioTimeStamp 		*inTimeStamp, 
					   UInt32 						inBusNumber, 
					   UInt32 						inNumberFrames, 
					   AudioBufferList 			*ioData)

{
	
	memset(ioData->mBuffers[0].mData, 0, ioData->mBuffers[0].mDataByteSize);
	
	if (sp == NULL) {
		return noErr;
	}
	
	int size = ioData->mBuffers[0].mDataByteSize;
	
	SInt16* output = (SInt16*)ioData->mBuffers[0].mData;
	for (int i = 0; i < size / 2; i++){
		double sec = (double)(inTimeStamp->mSampleTime + i) / SAMPLE_RATE;
		double wave = spGetValue(sp, sec);
		*output++ = wave * 32767.0;
	}
	
	return noErr;
}



-(void) createDefaultAU:(AudioUnit*) unit
{
	OSStatus err = noErr;
	
	// Open the default output unit
	ComponentDescription desc;
	desc.componentType = kAudioUnitType_Output;
	desc.componentSubType = kAudioUnitSubType_DefaultOutput;
	desc.componentManufacturer = kAudioUnitManufacturer_Apple;
	desc.componentFlags = 0;
	desc.componentFlagsMask = 0;
	
	Component comp = FindNextComponent(NULL, &desc);
	if (comp == NULL) { printf ("FindNextComponent\n"); return; }
	
	err = OpenAComponent(comp, unit);
	if (comp == NULL) { printf ("OpenAComponent=%ld\n", err); return; }
	
	// Set up a callback function to generate output to the output unit
    AURenderCallbackStruct input;
	input.inputProc = MyRenderer;
	input.inputProcRefCon = NULL;
	
	err = AudioUnitSetProperty (*unit, 
								kAudioUnitProperty_SetRenderCallback,
								//kAudioOutputUnitProperty_EnableIO,
								kAudioUnitScope_Input,		//initial value is "kAudioUnitScope_Input". is it ok?
								0,
								&input, 
								sizeof(input));	
	
}


-(void) setSpeaker:(Speaker*)spkr{
	sp = spkr;
}

-(id) init{
	
	sp = NULL;
	int sampleRate = SAMPLE_RATE;
	
	
	OSStatus err = noErr;
	
	[self createDefaultAU:&gOutputUnit];
	
	AudioStreamBasicDescription streamFormat;
	streamFormat.mSampleRate = sampleRate;		//	the sample rate of the audio stream
	streamFormat.mFormatID = kAudioFormatLinearPCM;			//	the specific encoding type of audio stream
	
#ifdef __BIG_ENDIAN__
	streamFormat.mFormatFlags =		kLinearPCMFormatFlagIsSignedInteger | kLinearPCMFormatFlagIsBigEndian
									| kLinearPCMFormatFlagIsPacked | kAudioFormatFlagIsNonInterleaved;		//	16bit int
#else
	streamFormat.mFormatFlags =		kLinearPCMFormatFlagIsSignedInteger 
		| kLinearPCMFormatFlagIsPacked | kAudioFormatFlagIsNonInterleaved;		//	16bit int
#endif
	
	streamFormat.mBytesPerPacket = 2;	
	streamFormat.mFramesPerPacket = 1;	
	streamFormat.mBytesPerFrame = 2;
	streamFormat.mChannelsPerFrame = 1;
	streamFormat.mBitsPerChannel = 16;
	
	err = AudioUnitSetProperty (gOutputUnit,
						  kAudioUnitProperty_StreamFormat,
						  kAudioUnitScope_Input,
						  0,
						  &streamFormat,
						  sizeof(AudioStreamBasicDescription));
	
	err = AudioUnitInitialize(gOutputUnit);
	
	Float64 outSampleRate;
	UInt32 size = sizeof(Float64);
	
	err = AudioUnitGetProperty (gOutputUnit,
								kAudioUnitProperty_SampleRate,
								kAudioUnitScope_Output,
								0,
								&outSampleRate,
								&size);
	
	
	err = AudioOutputUnitStart (gOutputUnit);
		
	// REALLY after you're finished playing STOP THE AUDIO OUTPUT UNIT!!!!!!	
	// but we never get here because we're running until the process is nuked...	
	
	return self;
}

@end
