//
//  FMController.h
//  MacFM
//
//  Created by KIMURA Hiroaki on 10/05/04.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include "Operator.h"
#import "WaveView.h"
#import "CoreAudioMixer.h"


#define NUMBER_OF_ARRAY 1000
#define TIME_LENGTH 0.005

@interface FMController : NSObject {
	
	Speaker* speaker;
	
	/**
	NSMutableArray* op1wave;
	NSMutableArray* op2wave;
	NSMutableArray* op3wave;
	NSMutableArray* carrierwave;
	**/
	double* op2wave;
	double* op3wave;
	double* carrierwave;
	
	 
	FMInfo* carrier;
	FMInfo* op3;
	FMInfo* op2;
	FMInfo* op1;
	BOOL mod2On;
	BOOL mod1On;
	
	IBOutlet WaveView* wv1;
	IBOutlet WaveView* wv2;
	IBOutlet WaveView* wv3;
	
	CoreAudioMixer* mixer;

}

@property double feedbackRate;

@property BOOL mod2On;
@property BOOL mod1On;

@property double op1freq;
@property double op2freq;
@property double op3freq;
@property double carrierFreq;

@property double op1mod;
@property double op2mod;
@property double op3mod;


@property double op2attack;
@property double op3attack;
@property double carrierattack;

@property double op2decay;
@property double op3decay;
@property double carrierdecay;

@property double op2sustain;
@property double op3sustain;
@property double carriersustain;

@property double op2release;
@property double op3release;
@property double carrierrelease;



@end
