//
//  FMController.m
//  MacFM
//
//  Created by KIMURA Hiroaki on 10/05/04.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "FMController.h"


@implementation FMController

double animTime = 0.0;

- (id) init{
	
	mod2On = YES;
	mod1On = YES;
	
	op2wave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);
	op3wave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);
	carrierwave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);

	memset(op2wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	memset(op3wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	memset(carrierwave, 0, sizeof(double) * NUMBER_OF_ARRAY);

	
	speaker = allocSpeaker();
	speaker->numOfParents = 0;
	
	carrier = allocFMInfo();
	
	op3 = allocFMInfo();
	op2 = allocFMInfo();
	op1 = allocFMInfo();

	
	spAddFMInfo(speaker, carrier);
	fmAddFmInfo(carrier, op3);
	fmAddFmInfo(op3, op2);
	//fmAddFmInfo(op2, op1);
	
	setCarrierFreq(carrier, 440.0);
	
	op3->attack = 0.2;
	op3->decay = 0.3;
	op3->sustain = 0.8;
	op3->release = 0.3;
	
	carrier->release = 1;
	
	mixer = [[CoreAudioMixer alloc] init];
	[mixer setSpeaker:speaker];
	
	
	
	
	return self;	
}

- (void) setFeedbackRate:(double)fb{
	op2->isFB = fb;
	[self calculateWave];

}

- (double)feedbackRate{
	return op2->isFB;
}

- (void) setMod1On:(BOOL)on{
	mod1On = on;
	if (!on){
		fmRemoveFmInfo(op3, op2);
	}else {
		if (!mod2On){
			[self setMod2On:YES];
		}
		fmAddFmInfo(op3, op2);
	}
	[self calculateWave];

}

- (BOOL) mod1On{
	return mod1On;
}

- (void) setMod2On:(BOOL)on{

	
	mod2On = on;
	
	if (!on) {
		fmRemoveFmInfo(carrier, op3);
	}else {
		fmAddFmInfo(carrier, op3);
	}
	[self calculateWave];

}

- (BOOL)mod2On{
	return mod2On;
}

- (void) awakeFromNib{
	wv1.array = op2wave;
	wv2.array = op3wave;
	wv3.array = carrierwave;
	
		
	[NSTimer scheduledTimerWithTimeInterval:0.03 
											 target:self
										   selector:@selector(animationTimer:)
										   userInfo:nil
											repeats:YES];
	
}

- (void)animationTimer:(NSTimer* )timer{
	[self calculateWave];

}



- (void) calculateWave{
	
	double dif = TIME_LENGTH / NUMBER_OF_ARRAY;
	
	double sec = speaker->sec;
	int tmpsec = (int)(sec * carrier->carrierFreq);
	sec = 1.0 / carrier->carrierFreq * tmpsec;
	
	
	for (int i = 0; i < NUMBER_OF_ARRAY; i++){
		
		carrierwave[i] = fmGetValue(carrier, sec) * 4.0 / carrier->modIndex;
		op3wave[i] = fmGetValue(op3, sec) * 4.0 / op3->modIndex;
		op2wave[i] = fmGetValue(op2, sec) * 4.0 / op2->modIndex;
		
		sec += dif;
	}
	
	if (!mod1On){
		memset(op2wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	}if (!mod2On){
		memset(op3wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	}
	[wv1 setNeedsDisplay:YES];
	[wv2 setNeedsDisplay:YES];
	[wv3 setNeedsDisplay:YES];

}



- (void)setCarrierFreq:(double)freq{
	setCarrierFreq(carrier, freq);
	setCarrierFreq(op2, freq);
	setCarrierFreq(op3, freq);
	[self calculateWave];
}

- (double) carrierFreq{
	return carrier->carrierFreq;

}

- (void) setOp3freq:(double)freq{
	op3->freqIndex = freq;
	[self calculateWave];

}

- (double) op3freq{
	return op3->freqIndex;

}

- (void) setOp2freq:(double)freq{
	op2->freqIndex = freq;
	[self calculateWave];

}

- (double) op2freq{
	return op2->freqIndex;
}


- (void) setOp1freq:(double)freq{
	op1->freqIndex = freq;
	[self calculateWave];

}

- (double) op1freq{
	return op1->freqIndex;
}


- (void) setOp3mod:(double)mod{
	op3->modIndex = mod;
	[self calculateWave];

}

- (double) op3mod{
	return op3->modIndex;
}

- (void) setOp2mod:(double)mod{
	op2->modIndex = mod;
	[self calculateWave];

}

- (double) op2mod{
	return op2->modIndex;
}

- (void) setOp1mod:(double)mod{
	op1->modIndex = mod;
	[self calculateWave];

}

- (double) op1mod{
	return op1->modIndex;
}

//EG
- (void) setCarrierattack:(double)attack{
	carrier->attack = attack;
}

- (double) carrierattack{
	return carrier->attack;
}

- (void) setCarrierdecay:(double)decay{
	carrier->decay = decay;
}

- (double) carrierdecay{
	return carrier->decay;
}

- (void) setCarriersustain:(double)sustain{
	carrier->sustain = sustain;
}

- (double) carriersustain{
	return carrier->sustain;
}

- (void) setCarrierrelease:(double)release{
	carrier->release = release;
}

- (double) carrierrelease{
	return carrier->release;
}

- (void) setOp3attack:(double)attack{
	op3->attack = attack;
}

- (double) op3attack{
	return op3->attack;
}

- (void) setOp3decay:(double)decay{
	op3->decay = decay;
}

- (double) op3decay{
	return op3->decay;
}

- (void) setOp3sustain:(double)sustain{
	op3->sustain = sustain;
}

- (double) op3sustain{
	return op3->sustain;
}

- (void) setOp3release:(double)release{
	op3->release = release;
}

- (double) op3release{
	return op3->release;
}

- (void) setOp2attack:(double)attack{
	op2->attack = attack;
}

- (double) op2attack{
	return op2->attack;
}

- (void) setOp2decay:(double)decay{
	op2->decay = decay;
}

- (double) op2decay{
	return op2->decay;
}

- (void) setOp2sustain:(double)sustain{
	op2->sustain = sustain;
}

- (double) op2sustain{
	return op2->sustain;
}

- (void) setOp2release:(double)release{
	op2->release = release;
}

- (double) op2release{
	return op2->release;
}

@end
